<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
	import="org.json.simple.JSONObject"
	import="org.json.simple.parser.JSONParser"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	String flowCellIdList = request.getParameter("flowcellidlist");
	String numLanesStringList = request.getParameter("numlaneslist");
	// Count number of id values
	int nFlowCells = 0;
	for (String s: flowCellIdList.split(","))
	{
		nFlowCells++;
	}
	// Get list of number of lanes per flow cell
	List<Integer> numLanesList = new ArrayList<Integer>();
	for (String s: numLanesStringList.split(","))
	{
		int numLanes = Integer.parseInt(s);
		numLanesList.add(numLanes);
	}
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title id="pageTitle">Lab protocol for flow cells></title>
	<link rel="SHORTCUT ICON" href="<%=home%>/images/flowcell.png">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/reggie.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<script language="JavaScript" src="<%=root%>/include/scripts/main.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root%>/include/scripts/ajax.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=home %>/reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	<script language="JavaScript">
	var debug = false;
	var currentStep = 1;
	
	function init()
	{
		var frm = document.forms['reggie'];
		var flowCellIdList = frm.fcIdList.value;
		// Load info on selected flow cells
		var flowCellInfo = getFlowCellInfo(flowCellIdList);
		viewAsList(flowCellInfo);
	}
	
	/**
	 * Returns a JSONArray with data for flow cells with database id values
	 * in input comma-separated string list.
	 *
	 * @param idList A comma-separated list of flow cell database id values.
	 * @return JSONArray with data for flow cells with input database id values.
	 */
	function getFlowCellInfo(idList)
	{
		var frm = document.forms['reggie'];	

		var request = Ajax.getXmlHttpRequest();
		try
		{
			showLoadingAnimation('Loading flow cell info...');
			var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetFlowCellInfo';
			url += '&idlist='+idList;
			request.open("GET", url, false);	
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}
	
		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		return response.flowCellInfo;
	}

	function viewAsList(flowCellInfoArray)
	{
		var flowCellNo = -1;
		var flowCellNameList = '';
		for (var index in flowCellInfoArray)
		{
			flowCellNo++;
			var flowCell = flowCellInfoArray[index];
			var flowCellName = flowCell['name'];
			if (flowCellNo > 0)
			{
				flowCellNameList += ',';
			}
			flowCellNameList += flowCellName;
			setInnerHTML('flowCellName.'+flowCellNo, flowCellName);				
			setInnerHTML('flowCellName2.'+flowCellNo, flowCellName);				
			setInnerHTML('flowCellDescription.'+flowCellNo, flowCell.description);				
			setInnerHTML('sequencingCycles.'+flowCellNo, flowCell.SequencingCycles);
			setInnerHTML('flowCellId.'+flowCellNo, flowCell.externalId);
			var flowCellLanes = flowCell['lanes'];
			for (laneKey in flowCellLanes)
			{
				var poolId = flowCellLanes[laneKey];
				var row = laneKey - 1;
				var idSuffix = flowCellNo + '.' + row;
				setInnerHTML('fcPoolName.'+idSuffix, poolId);				
			}
		}
		var pageTitle = 'Lab protocol for ' + flowCellNameList;
		setInnerHTML('pageTitle', pageTitle);				
		Main.show('listviewcontainer');
	}
	
	</script>
	<style>
	
	h2
	{
		margin-bottom: 0;
		font-size: 1.2em;
	}
	
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
		min-height: 20em;
		height: 20em;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: middle;
		height: 2.5em;
		max-height: 2.5em;
		border-bottom: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 4px;
		border-right: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th.subprompt
	{
		text-align: right;
		font-weight: normal;
	}

	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 4px;
	}
	
	.colorbox 
	{
		display: inline-block;
		width: 0.8em; 
		height: 0.8em; 
		border: 1px solid #000000;
		margin-left: 1em;
		margin-right: 0.5em;
	}
	
	.pools
	{
		width: 100%;
		border-collapse: collapse;
	}
	
	.pools tr
	{
		height: 2.5em;
		border-bottom: 1px dotted #666666;
	}

	.pools tr:last-child
	{
		border-bottom: 0;
	}
	
	.pools td, .pools th
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	.pools th
	{
		background-color: #F0F0F0;
		border-bottom: 1px solid #000000;
	}
	
	.pools .lane-no
	{
		width: 5em;
		text-align: center;
	}
	
	.pools .pool-name
	{
		width: 8em;
	}
	
	</style>
</head>
<body onload="init()">
	<div class="paper">
	<form name="reggie" onsubmit="return false;" action="flowcell_protocol2.jsp" method="post" target="_blank">
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<span class="button" onclick="window.print()" style="float: left; margin-right: 1em;">
			<img src="../images/print.png">Print&hellip;
		</span>
		<b>Note!</b> 
		For better printing reduce margins to about <i>5mm</i> and set page orientation
		to <i>portrait</i>.
		<br clear="all">
	</div>
	
	<h1>Lab protocol for clustering and sequencing startup <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<input type="hidden" name="fcIdList" value="<%=flowCellIdList%>">

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	<div class="messagecontainer error" id="errorMessage" style="display: none;"></div>
	<div id="listviewcontainer" style="display: none;">
	
	
	<h2>1. Clustering</h2>
	
	<%
	// Note: Variable 'c' here indicates a flow cell, not a table column
	// Each flow cell is shown in its own table
	for (int c = 0; c < nFlowCells; ++c)
	{
		%>
		<table style="width: 100%;" class="protocolheader">
		<tr>
			<th style="width: 15%;">Flow cell</th>
			<td style="width: 35%;"><div id="flowCellName.<%=c%>" >Flow cell name <%=c%></div></td>
			<td style="width: 50%; padding: 0; vertical-align: top; border-left: 1px solid #000000;" rowspan="5">
				<table class="pools">
				<tr>
					<th class="lane-no">Lane</th>
					<th class="pool-name">Pool name</th>
					<th class="remarks">Remarks</th>
				</tr>
				<tbody>
				<%
				int rows = (Integer) numLanesList.get(c);
				for (int r = 0; r < rows; ++r)
				{
					String idSuffix = c + "." + r;
					%>
					<tr id="row.<%=idSuffix%>">
						<td class="lane-no"><%=r+1%></td>
						<td class="pool-name" id="fcPoolName.<%=idSuffix%>"></td>
						<td class="remarks" id="fcPoolRemarks.<%=idSuffix%>"></td>
					</tr>
					<%
				}
				%>
				</tbody>
				</table>
			
			
			</td>
		</tr>
		<tr>
			<th>Flow cell ID</th>
			<td id="flowCellId.<%=c%>"></td>
		</tr>
		<tr>
			<th>Operator</th>
			<td></td>
		</tr>
		<tr>
			<th>Date</th>
			<td></td>
		</tr>
		
		<tr style="max-height: 100%; height: auto; vertical-align: top;">
			<td colspan="2" id="flowCellDescription.<%=c%>"></td>
		</tr>
		</table>
		<%
	}
	%>
	
	<h2>2. Sequencing startup</h2>
	
	<table class="protocolheader">
	<tr>
		<th style="width: 25%;">Sequencing machine</th>
		<td style="width: 75%;" colspan="2"></td>
	</tr>
	<tr>
		<th>Date</th>
		<td colspan="2"></td>
	</tr>
	<tr>
		<th>Operator</th>
		<td colspan="2"></td>
	</tr>
	
	<tr>
		<th></th>
		<th style="width: 20%; border-right: 0;">HiSeq position</th>
		<th>Sequencing cycles (Read 1 - Index - Read 2)</th>
	</tr>

	<%
	// Note: Variable 'c' here indicates a flow cell, not a table column
	// Each flow cell is shown in its own table
	for (int c = 0; c < nFlowCells; ++c)
	{
		%>
		<tr>
			<th id="flowCellName2.<%=c%>" class="subprompt">Flowcell<%=c %></th>
			<td><b><div class="colorbox"></div>A <div class="colorbox"></div>B</b></td>
			<td><div id="sequencingCycles.<%=c%>"></div></td>
		</tr>
		<%
	}
	%>
	<tr style="height: 7em; vertical-align: top;">
		<th>Comments</th>
		<td colspan="2"></td>
	</tr>
	</table>
	</div>
	</form>
	</div>
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>