<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyyMMdd").format(new Date());
%>
<base:page type="default" >
<base:head scripts="ajax.js,tabcontrol.js" styles="path.css,toolbar.css,tabcontrol.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

function init()
{
	document.getElementById('set-focus').focus();	
	
	//Main.show('he-glass-set.he.2.content');
	//Main.show('he-glass-set.he.3.content');
}

function selectHeGlass()
{
	var url = getRoot() + 'biomaterials/bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
	url += '&resetTemporary=1';
	url += '&filter:STRING:name=HE%';	
	Main.openPopup(url, 'SelectHeGlass', 1050, 700);
}
</script>
<style>

#he-glass-set .tabcontents
{
	border-left: 1px solid #A0A0A0;
	border-right: 1px solid #A0A0A0;
	border-bottom: 1px solid #A0A0A0;
	background: #ffffff;
	min-height: 30em;
}

#he-glass-set .tabcontents > div
{
	float: left;
}

.he-glass
{
	border: 1px solid #A0A0A0;
	float: left;
	margin: 1em;
	width: 200px;
	background: #E8E8E8;
}

.he-name
{
	font-weight: bold; 
	background-color: #E0E0E0; 
	border-bottom: 1px solid #A0A0A0; 
	padding: 0.5em;
}

.he-info
{
	background-color: #FFFFFF; 
	border-bottom: 1px solid #A0A0A0;
	padding: 0.5em;
	height: 4em;
	overflow: auto;
}

.he-comment
{
	font-style: italic;
}

.other-glass
{
	font-style: italic;
}

.progress
{
	
}

.heglass
{
	margin-top: 1em;
	margin-bottom: 1em;
	margin-left: auto;
	margin-right: auto;
	xmargin-top: 1em;
	xmargin-bottom: 1em;
	xmargin-left: auto;
	xmargin-right: auto;
	width: 150px;
}

.heglass td
{
	width: 75px;
	height: 75px;
	border: 1px solid #A0A0A0;
	padding: 2px;
	background: #FFFFFF;
	xbackground-image: url("../images/bullet_white.png");
	background-position: center center;
	background-repeat: no-repeat;
	vertical-align: top;
	text-align: center;
	font-size: 85%;
	color: #666666;
	cursor: pointer;
}

.heglass td.not-used
{
	background-color: #E0E0E0;
	background-image: url("../images/not-used.png");
	cursor: default;
}

.heglass td.good-stain
{
	font-weight: bold;
	color: #000000;
	background-image: url("../images/noscore.png");
}


.heglass td.good-stain.scored
{
	background-image: url("../images/rnaqc.png");
}

.heglass td.good-stain.scored-half
{
	background-image: url("../images/rnaqc_half.png");
}


.heglass td:hover
{
	border: 2px solid #2288AA;
	border-radius: 4px;
	padding: 1px;
}

.heglass td.selected
{
	border: 2px solid #2288AA;
	background-color: #D8FFFF;
	border-radius: 4px;
	padding: 1px;
}

.sectionheader th
{
	padding: 0.5em !important;
}

</style>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register HE glass score" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>
	<form name="reggie" onsubmit="return false;" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	
	<table class="stepform" id="print-version">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">HE glass to score</td>
	</tr>
	<tr>
		<td class="stepfields">
			<tbl:toolbar subclass="bottomborder">
				<tbl:label>
				<input type="text" style="width: 12em;" placeholder="Find HE glass" tooltip="Enter a HE glass name">
				<img src="../images/gonext.png">
				</tbl:label>
				
				<tbl:button
					title="4 uncompleted HE glass"
					image="mini_scroll_down.png"
				/>
			
				<tbl:button 
					title="Select HE glass&hellip;" 
					image="<%=home + "/images/microscope.png"%>" 
					onclick="selectHeGlass()"
					tooltip="Manually select a different HE glass"
				/>
			</tbl:toolbar>
			

				<div style="xwidth: 50em;">
					
					<div class="he-glass">
						<div class="he-name">HE0001.1</div>
						<div class="he-info">
							Tray 1; pos 1
							<div class="he-comment">
							overall a bit more tissue than HE...2
							</div>
						</div>
					
						<table class="heglass">
							<tr>
								<td class="not-used"></td>
								<td class="good-stain selected scored-half">112233.1.his
									<div class="progress">35%</div>
								</td>
							</tr>
							<tr>
								<td>7700026.1.his
								</td>
								<td>4405401.1.his
								</td>
							</tr>
							<tr>
								<td class="good-stain scored">6605802.1.his
									<div class="progress">100%</div>
								</td>
								<td>2205601.1.his
								<div class="progress">100%</div>
								</td>
							</tr>
						</table>
					</div>
					
					<div class="he-glass">
						<div class="he-name">HE0001.2</div>
						<div class="he-info">
							Tray 1; pos 2
							<div class="he-comment">
							
							</div>
						</div>
						<table class="heglass">
							<tr>
								<td class="not-used"></td>
								<td>112233.1.his
								</td>
							</tr>
							<tr>
								<td class="good-stain">7700026.1.his
									<div class="progress">0%</div>
								</td>
								<td>4405401.1.his
								</td>
							</tr>
							<tr>
								<td>6605802.1.his
								</td>
								<td class="good-stain">2205601.1.his
									<div class="progress">0%</div>
								</td>
							</tr>
						</table>
					</div>
					
					<div class="he-glass">
						<div class="he-name">HE0001.3</div>
						<div class="he-info">
							Tray 1; pos 3
							<div class="he-comment">
							
							</div>
						</div>

						<table class="heglass">
							<tr>
								<td class="not-used"></td>
								<td>112233.1.his
								</td>
							</tr>
							<tr>
								<td>7700026.1.his
								</td>
								<td class="good-stain">4405401.1.his
									<div class="progress">0%</div>
								</td>
							</tr>
							<tr>
								<td>6605802.1.his
								</td>
								<td>2205601.1.his
								</td>
							</tr>
						</table>
					</div>
					
				</div>
				
			<br clear="all">
			
					<div style="border: 1px solid #A0A0A0; margin: 1em;">
						<table class="fullform input100">
						<tbody class="sectionheader">
							<tr>
								<th>Scores</th>
								<th colspan="3">112233.1.his.he1</th>
							</tr>
						</tbody>
						<tbody>
						<tr>
							<th>Invasive cancer</th>
							<td style="width: 12em;"><input type="text" style="width: 6em;" value="20">%</td>
							<td style="width: 2em;"><img src="../images/ok.png"></td>
							<td class="help"></td>
						</tr>		
	
						<tr>
							<th>In situ cancer</th>
							<td><input type="text" style="width: 6em;" value="15">%</td>
							<td><img src="../images/ok.png"></td>
							<td class="help"></td>
						</tr>		
						<tr>
							<th>Lymphocytes</th>
							<td><input type="text" style="width: 6em;" id="set-focus">%</td>
							<td></td>
							<td class="help"></td>
						</tr>		
						<tr>
							<th>Normal</th>
							<td><input type="text" style="width: 6em;">%</td>
							<td></td>
							<td class="help"></td>
						</tr>		
						<tr>
							<th>Stroma</th>
							<td><input type="text" style="width: 6em;">%</td>
							<td></td>
							<td class="help"></td>
						</tr>		
						<tr>
							<th>Fat</th>
							<td><input type="text" style="width: 6em;">%</td>
							<td></td>
							<td class="help"></td>
						</tr>		

						<tr>
							<th>Total</th>
							<td>35%</td>
							<td><img src="../images/warning.png"></td>
							<td class="help"><span class="message warning">Not 100%</span></td>
						</tr>
						
						<tr>
							<th class="subprompt">Not complete</th>
							<td><input type="checkbox" checked disabled></td>
							<td></td>
							<td class="help"></td>
						</tr>
						
						<tr>
							<th class="subprompt">GoodStain</th>
							<td><input type="checkbox" checked disabled></td>
							<td></td>
							<td class="help"></td>
						</tr>
						
						<tr style="border-top: 1px dotted #cccccc;">
							<th>Comments</th>
							<td colspan="3" style="border-top: 1px dotted #cccccc; padding-top: 0.5em; padding-bottom: 0.5em;">
								<textarea rows="5" style="width: 90%;" name="comments" value=""></textarea>
							</td>
						</tr>
						</tbody>
						</table>
					</div>		
			
		</td>
	</tr>
	</table>
	

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" /></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="gocreate" title="Save" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"><input type="checkbox" checked disabled>As not completed</td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>